"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/filter"));

var _context, _context2;

const {
  packageManager
} = require('../jsonate/');

const {
  resolveNdvScripts,
  resolveBin,
  isOptedOut
} = require('../utils');

const ndvScripts = resolveNdvScripts();
const doctoc = resolveBin('doctoc');
const {
  ifAnyDep,
  hasAnyDep
} = packageManager();
const isTypeScript = !hasAnyDep('lerna') && hasAnyDep('typescript');
const isLernaTypeScript = hasAnyDep('lerna') && hasAnyDep('typescript');
module.exports = {
  '**/*package.json': (0, _filter.default)(_context = [hasAnyDep('lerna') ? () => `${resolveBin('lerna')} link convert` : false, ifAnyDep('lerna', 'yarn bootstrap'), `${resolveBin('prettier-package-json')} --write`, 'git add', ifAnyDep('lerna', 'git add yarn.lock')]).call(_context, Boolean),
  '**/*.ts?(x)': () => isLernaTypeScript ? [`${resolveBin('tsc')} --build`] : isTypeScript ? [`${resolveBin('tsc')} --noEmit`] : [],
  'README.md': [`${doctoc} --maxlevel 4 --notitle`, 'git add'],
  '**/*.+(js|json|less|css|ts|tsx|md)': (0, _filter.default)(_context2 = [isOptedOut('autoformat', null, `${ndvScripts} format`), `${ndvScripts} lint`, `${ndvScripts} test --findRelatedTests --passWithNoTests`, isOptedOut('autoformat', null, 'git add')]).call(_context2, Boolean)
};