"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));

var _context;

process.env.BABEL_ENV = 'test';
process.env.NODE_ENV = 'test';

const jestConfig = require('./jest.config');

const babelrc = require('./babelrc')();

const files = ['./src/**/*.json', ...jestConfig.collectCoverageFrom, ...(0, _map.default)(_context = jestConfig.testMatch).call(_context, file => `!${file}`), '!dist', '!node_modules'];
const tests = [...jestConfig.testMatch, '!node_modules', '!dist']; // eslint-disable-next-line func-names

module.exports = function (wallaby) {
  const config = {
    debug: true,
    env: {
      type: 'node',
      runner: 'node'
    },
    testFramework: 'jest',
    files,
    tests,
    compilers: {
      '**/*.{js,ts,tsx}': wallaby.compilers.babel((0, _extends2.default)({
        babelrc: true
      }, babelrc))
    }
  };
  return config;
};