"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/some"));

const fs = require('fs');

const arrify = require('arrify');

const readPkgUp = require('read-pkg-up');

const shared = require('./shared').shared;

const packageManager = ({
  cwd = process.cwd(),
  initialState = {}
} = {}) => shared({
  initialState,
  configFn: props => {
    const {
      hasSubProp,
      ifSubProp,
      setState,
      getState
    } = props;

    if (!getState().isLoaded) {
      const {
        pkg: config,
        path: configPath
      } = readPkgUp.sync({
        cwd: fs.realpathSync(cwd)
      });
      setState(() => ({
        filename: 'package.json',
        config,
        configPath,
        isLoaded: true
      }));
    }

    const hasAnyDep = args => {
      var _context;

      return (0, _some.default)(_context = [hasSubProp('dependencies'), hasSubProp('devDependencies'), hasSubProp('peerDependencies')]).call(_context, fn => fn(args));
    };

    const ifDep = ifSubProp('dependencies');
    const ifDevDep = ifSubProp('devDependencies');
    const ifPeerDep = ifSubProp('peerDependencies');
    const ifScript = ifSubProp('scripts');
    return (0, _extends2.default)({}, props, {
      hasAnyDep,
      hasDep: dep => hasSubProp('dependencies')(dep),
      hasDevDep: devDep => hasSubProp('devDependencies')(devDep),
      hasPeerDep: peerDep => hasSubProp('peerDependencies')(peerDep),
      hasScript: script => hasSubProp('scripts')(script),
      ifAnyDep: (deps, t, f) => hasAnyDep(arrify(deps)) ? t : f,
      ifDep,
      ifDevDep,
      ifPeerDep,
      ifScript
    });
  }
});

module.exports = {
  packageManager
};