"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/some"));

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

const fs = require('fs');

const arrify = require('arrify');

const get = require('lodash.get');

const has = require('lodash.has');

const findUp = require('find-up');

const parseJson = require('parse-json');

function shared({
  configFn,
  initialState
}) {
  let state = (0, _extends2.default)({
    config: undefined,
    configPath: undefined,
    filename: undefined,
    isLoaded: false
  }, initialState);

  const setState = fn => state = (0, _extends2.default)({}, state, {}, fn(state));

  const getState = () => state;

  const reload = () => {
    if (!state.configPath) throw new Error(`Please load a config file first!`);
    setState(() => ({
      isLoaded: false
    }));
    const config = parseJson(fs.readFileSync(state.configPath, 'utf8'));
    setState(() => ({
      config,
      isLoaded: true
    }));
  };

  const getProp = prop => get(state.config, `${prop}`);

  const hasProp = props => {
    var _context;

    if (!state.config) {
      throw new Error('Please load a config file first!');
    }

    return (0, _some.default)(_context = arrify(props)).call(_context, prop => has(state.config, prop));
  };

  const hasSubProp = prop => props => {
    var _context2;

    return hasProp((0, _map.default)(_context2 = arrify(props)).call(_context2, p => `${prop}.${p}`));
  };

  //TODO: look at freeezing this returned object
  return configFn({
    getProp,
    getState,
    getSubProp: prop => subProp => get(state.config, `${prop}.${subProp}`),
    hasProp,
    hasSubProp,
    ifSubProp: prop => (props, t, f) => hasSubProp(prop)(props) ? t : f,
    load: (filename, {
      cwd = process.cwd()
    } = {}) => {
      if (!filename) throw new Error('A filename must be passed in!');
      const configPath = findUp.sync(filename, {
        cwd
      });
      const config = parseJson(fs.readFileSync(configPath, 'utf8'));
      setState(() => ({
        configPath,
        config,
        isLoaded: true,
        filename
      }));
    },
    reload,
    setState
  });
}

module.exports = {
  shared
};