"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

const shared = require('./shared').shared;

const tsConfigManager = ({
  filename = 'tsconfig.json',
  cwd = process.cwd(),
  initialState = {}
} = {}) => shared({
  initialState,
  configFn: props => {
    const {
      getState
    } = props;

    if (!getState().isLoaded) {
      props.load(filename, {
        cwd
      });
    }

    return (0, _extends2.default)({}, props, {
      getCompilerOption: compilerOption => props.getSubProp('compilerOptions')(compilerOption),
      hasCompilerOption: compilerOption => props.hasSubProp('compilerOptions')(compilerOption),
      getFiles: () => props.getProp('files')
    });
  }
});

module.exports = {
  tsConfigManager
};