"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/concat"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/slice"));

const spawn = require('cross-spawn');

const rimraf = require('rimraf');

const {
  fromRoot,
  fromConfigs,
  resolveBin,
  useBuiltInBabelConfig
} = require('../../utils');

function build() {
  var _context, _context2;

  const args = (0, _slice.default)(_context = process.argv).call(_context, 2);
  const useBuiltinConfig = useBuiltInBabelConfig(args);
  const config = useBuiltinConfig ? ['--presets', fromConfigs('babelrc.js')] : [];
  const ignore = (0, _includes.default)(args).call(args, '--ignore') ? [] : ['--ignore', '**/__tests__/**,**/__mocks__/**'];
  const copyFiles = (0, _includes.default)(args).call(args, '--no-copy-files') ? [] : ['--copy-files'];
  const useSpecifiedOutDir = (0, _includes.default)(args).call(args, '--out-dir');
  const outDir = useSpecifiedOutDir ? [] : ['--out-dir', 'dist'];

  if (!useSpecifiedOutDir && !(0, _includes.default)(args).call(args, '--no-clean')) {
    rimraf.sync(fromRoot('dist'));
  }

  const finalArgs = (0, _concat.default)(_context2 = [...outDir, ...config, ...copyFiles, ...ignore, 'src']).call(_context2, args);
  const result = spawn.sync(resolveBin('@babel/cli', {
    executable: 'babel'
  }), finalArgs, {
    stdio: 'inherit'
  });
  return result;
}

module.exports = {
  build
};