"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));

/* eslint-disable no-useless-escape */
const {
  hasTypescriptFiles,
  print
} = require('../../utils');

function build() {
  try {
    var _context3;

    let result;

    if (hasTypescriptFiles()) {
      var _context, _context2;

      //await verifyTypescript()
      const useSpecifiedExtensions = (0, _includes.default)(_context = process.argv).call(_context, '--extensions');

      if (!useSpecifiedExtensions) {
        process.argv = [...process.argv, '--extensions', ['.es6', '.es', '.jsx', '.js', '.mjs', '.ts', '.tsx'].join(',')];
      }

      const useSpecifiedSourceMaps = (0, _includes.default)(_context2 = process.argv).call(_context2, '--source-maps');

      if (!useSpecifiedSourceMaps) {
        process.argv = [...process.argv, '--source-maps', 'inline'];
      }
    }

    if ((0, _includes.default)(_context3 = process.argv).call(_context3, '--bundle')) {
      result = require('./rollup').build();
    } else {
      result = require('./babel').build();
    }

    if (result.status > 0) {
      print(`Build FAILED ¯\_(ツ)_/¯`); // eslint-disable-next-line no-process-exit

      process.exit(1);
    }

    if (result.status === 0 && hasTypescriptFiles()) {
      process.argv = []; //TODO: move handling of result into build-types.js

      result = require('../build-types').build();

      if (result.status > 0) {
        print(`Compiling type declarations FAILED ¯\_(ツ)_/¯`); // eslint-disable-next-line no-process-exit

        process.exit(1);
      } else {
        print(`Successfully compiled type declarations.`);
      }
    }
  } catch (error) {
    print(`Build FAILED ¯\_(ツ)_/¯`);
    print(error);
  }
}

(async () => {
  await build();
})();