"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/concat"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/slice"));

var _context, _context2;

const spawn = require('cross-spawn');

const yargsParser = require('yargs-parser');

const {
  resolveBin,
  hasFile,
  fromConfigs
} = require('../utils');

const {
  packageManager
} = require('../jsonate');

const args = (0, _slice.default)(_context = process.argv).call(_context, 2);
const parsedArgs = yargsParser(args);
const {
  hasProp: hasPkgProp
} = packageManager();
const useBuiltinConfig = !(0, _includes.default)(args).call(args, '--config') && !hasFile('.prettierrc') && !hasFile('prettier.config.js') && !hasPkgProp('prettier');
const config = useBuiltinConfig ? ['--config', fromConfigs('prettier.config.js')] : [];
const useBuiltinIgnore = !(0, _includes.default)(args).call(args, '--ignore-path') && !hasFile('.prettierignore');
const ignore = useBuiltinIgnore ? ['--ignore-path', fromConfigs('prettierignore')] : [];
const write = (0, _includes.default)(args).call(args, '--no-write') ? [] : ['--write']; // this ensures that when running format as a pre-commit hook and we get
// the full file path, we make that non-absolute so it is treated as a glob,
// This way the prettierignore will be applied

const relativeArgs = (0, _map.default)(args).call(args, a => a.replace(`${process.cwd()}/`, ''));
const filesToApply = parsedArgs._.length ? [] : ['**/*.+(js|jsx|json|less|css|ts|tsx|md)'];
const result = spawn.sync(resolveBin('prettier'), (0, _concat.default)(_context2 = [...config, ...ignore, ...write, ...filesToApply]).call(_context2, relativeArgs), {
  stdio: 'inherit'
}); // eslint-disable-next-line no-process-exit

process.exit(result.status);