"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/set-timeout"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/promise"));

var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/set"));

var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/array/from"));

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/json/stringify"));

var _values = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/object/values"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/map"));

var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/filter"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/concat"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/object/keys"));

var _entries = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/object/entries"));

var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/reduce"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/some"));

//TODO: imporve test converage
const util = require('util');

const exec = util.promisify(require('child_process').exec);

const fs = require('fs');

const path = require('path');

const glob = require('glob');

const mkdirp = require('mkdirp');

const rimraf = require('rimraf');

const which = require('which');

const arrify = require('arrify');

const {
  packageManager
} = require('./jsonate');

function getAppDirectory() {
  const {
    getState: getPkgState
  } = packageManager();
  return path.dirname(getPkgState().configPath);
}

function resolveNdvScripts() {
  const {
    getProp: getPkgProp
  } = packageManager();

  if (getPkgProp('name') === 'easy-scripts') {
    return require.resolve('./').replace(process.cwd(), '.');
  }

  return resolveBin('easy-scripts');
} // eslint-disable-next-line complexity


function resolveBin(modName, {
  executable = modName,
  cwd = process.cwd()
} = {}) {
  let pathFromWhich;

  try {
    pathFromWhich = fs.realpathSync(which.sync(executable));
  } catch (_error) {// ignore _error
  }

  try {
    const modPkgPath = require.resolve(`${modName}/package.json`);

    const modPkgDir = path.dirname(modPkgPath);

    const {
      bin
    } = require(modPkgPath);

    const binPath = typeof bin === 'string' ? bin : bin[executable];
    const fullPathToBin = path.join(modPkgDir, binPath);

    if (fullPathToBin === pathFromWhich) {
      return executable;
    }

    return fullPathToBin.replace(cwd, '.');
  } catch (error) {
    if (pathFromWhich) {
      return executable;
    }

    throw error;
  }
}

const fromRoot = (...p) => path.join(getAppDirectory(), ...p);

const hasFile = (...p) => fs.existsSync(fromRoot(...p));

const ifFile = (files, t = true, f = false) => {
  var _context;

  return (0, _some.default)(_context = arrify(files)).call(_context, file => hasFile(file)) ? t : f;
};

function parseEnv(name, def) {
  if (envIsSet(name)) {
    try {
      return JSON.parse(process.env[name]);
    } catch (err) {
      return process.env[name];
    }
  }

  return def;
}

function envIsSet(name) {
  return process.env.hasOwnProperty(name) && process.env[name] && process.env[name] !== 'undefined';
}

function getConcurrentlyArgs(scripts, {
  killOthers = true
} = {}) {
  var _context2, _context3, _context4, _context5;

  const colors = ['bgBlue', 'bgGreen', 'bgMagenta', 'bgCyan', 'bgWhite', 'bgRed', 'bgBlack', 'bgYellow'];
  scripts = (0, _reduce.default)(_context2 = (0, _entries.default)(scripts)).call(_context2, (all, [name, script]) => {
    if (script) {
      all[name] = script;
    }

    return all;
  }, {});
  const prefixColors = (0, _reduce.default)(_context3 = (0, _keys.default)(scripts)).call(_context3, (pColors, _s, i) => (0, _concat.default)(pColors).call(pColors, [`${colors[i % colors.length]}.bold.reset`]), []).join(','); // prettier-ignore

  return (0, _filter.default)(_context4 = [killOthers ? '--kill-others-on-fail' : null, '--prefix', '[{name}]', '--names', (0, _keys.default)(scripts).join(','), '--prefix-colors', prefixColors, ...(0, _map.default)(_context5 = (0, _values.default)(scripts)).call(_context5, s => (0, _stringify.default)(s))]).call(_context4, Boolean);
}

function isOptedOut(key, t = true, f = false) {
  if (!fs.existsSync(fromRoot('.opt-out'))) {
    return f;
  }

  const contents = fs.readFileSync(fromRoot('.opt-out'), 'utf-8');
  return (0, _includes.default)(contents).call(contents, key) ? t : f;
}

function isOptedIn(key, t = true, f = false) {
  if (!fs.existsSync(fromRoot('.opt-in'))) {
    return f;
  }

  const contents = fs.readFileSync(fromRoot('.opt-in'), 'utf-8');
  return (0, _includes.default)(contents).call(contents, key) ? t : f;
}

function uniq(arr) {
  return (0, _from.default)(new _set.default(arr));
}

function writeExtraEntry(name, {
  cjs,
  esm
}, clean = true) {
  if (clean) {
    rimraf.sync(fromRoot(name));
  }

  mkdirp.sync(fromRoot(name));
  const pkgJson = fromRoot(`${name}/package.json`);
  const entryDir = fromRoot(name);
  fs.writeFileSync(pkgJson, (0, _stringify.default)({
    main: path.relative(entryDir, cjs),
    'jsnext:main': path.relative(entryDir, esm),
    module: path.relative(entryDir, esm)
  }, null, 2));
} //TODO: should this throw an error?
//TODO: add this to jsonate


function createConfig(p, c) {
  fs.writeFileSync(p, c, err => {
    if (err) {
      print(err);
    }

    print('The file was saved!');
  });
}

function execCmd(command, options = {}, silent = true) {
  if (!silent) {
    //TODO: use print to colwidth here .... DONE
    print(command);
  }

  return exec(command, options).then(response => response.stdout).catch(error => {
    if (error.stderr === '') return error.stdout;
    throw error;
  });
}

function wait(timeout) {
  return new _promise.default(resolve => {
    (0, _setTimeout2.default)(() => resolve(), timeout);
  });
}

function print(message) {
  // eslint-disable-next-line no-console
  console.info(message);
}

function useBuiltInBabelConfig(args) {
  const {
    hasProp: hasPkgProp
  } = packageManager();
  return isDogfooding() || !(0, _includes.default)(args).call(args, '--presets') && !hasFile('.babelrc') && !hasFile('.babelrc.js') && !hasFile('babel.config.js') && !hasPkgProp('babel');
}

function useBuiltInEslintConfig(args) {
  const {
    hasProp: hasPkgProp
  } = packageManager();
  return isDogfooding() || !(0, _includes.default)(args).call(args, '--config') && !hasFile('.eslintrc') && !hasFile('.eslintrc.js') && !hasPkgProp('eslintConfig');
}

function useBuiltInEslintIgnore(args) {
  const {
    hasProp: hasPkgProp
  } = packageManager();
  return isDogfooding() || !(0, _includes.default)(args).call(args, '--ignore-path') && !hasFile('.eslintignore') && !hasPkgProp('eslintIgnore');
}

function fromConfigs(p) {
  return path.join(__dirname, './config/', p);
}

function hasTypescriptFiles() {
  return !isDogfooding() && glob.sync(fromRoot('!(node_modules)/**/*.{ts,tsx}')).length > 0;
}

function isDogfooding() {
  const {
    getProp: getPkgProp
  } = packageManager();
  return getPkgProp('name') === 'easy-scripts';
}

function ifTypescriptProject(t = true, f = false) {
  return hasTypescriptFiles() ? t : f;
}

function printStage(stage) {
  // eslint-disable-next-line no-console
  console.info(`\n===> ${stage} <===\n`);
}

module.exports = {
  createConfig,
  envIsSet,
  execCmd,
  fromConfigs,
  fromRoot,
  getAppDirectory,
  getConcurrentlyArgs,
  hasFile,
  hasTypescriptFiles,
  ifFile,
  isDogfooding,
  ifTypescriptProject,
  isOptedIn,
  isOptedOut,
  parseEnv,
  print,
  printStage,
  resolveBin,
  resolveNdvScripts,
  uniq,
  useBuiltInEslintConfig,
  useBuiltInEslintIgnore,
  useBuiltInBabelConfig,
  wait,
  writeExtraEntry
};